Subject: RFC 4758 issues and ERRATA

From: Alfred Hönes <[email-masked]>
Date: Mon, 1 Jan 2007 22:13:50 +0100 (MEZ)

Hello,
after studying the recently published RFC 4758 (CT-KIP) authored
by you, I would like to submit a few comments, pointing out some
inconsitencies and other issues I found with the RFC text, and
supplying material for an appropriate RFC Errata Note.

The items below are presented in RFC textual order.
I use change bars ('|' in column 1) and occasionally
up/down pointing marker lines ('^^^'/'vvv') to emphasize
the location of textual issues and/or proposed corrections.

(1)  [simple typo]

The second paragraph of Section 3.7.1, on page 13, says:
                                        vv
|  The XML format for CT-KIP messages have been designed to be
   extensible.  [...]

It should say:
                                        v
|  The XML format for CT-KIP messages has been designed to be
   extensible.  [...]

(2)  [XML schema inconsistencies]

The XML Schema fragment presented in Section 3.8.2 is
inconsistent with the full XML Schema in Appendix A
(cf. page 43).
Cross-checking with the examples presented in Appendix B and
looking for similarities, I strongly suspect that the second-to-last
line on page 17 of RFC 4758 is spurious and should be deleted.
Furthermore, there is a spurious (non-declared) namespace prefix
appearing on page 18 that should be deleted as well.

Hence:

(2a)

The final 3 lines at the bottom of page 17,

     </xs:sequence>
|    <xs:attribute name="id" type="xs:ID"/>
   </xs:complexType>

in fact should say:

     </xs:sequence>
   </xs:complexType>

(2b)

The final two XML schema lines on mid-page 18,
                                        vvvvvvv
|    <xs:attribute name="Version" type="ct-kip:VersionType"/>
   </xs:complexType>

in fact should say:

|    <xs:attribute name="Version" type="VersionType"/>
   </xs:complexType>

(3)  [misleading text ??]

The bullet on mid-page 22, within Section 3.8.4 of RFC 4758, says:

|  o  <MacAlgorithm>: The MAC algorithm to be used by the CT-KIP server.
                                        ^^^^^^
I suspect (but I am not 100% sure) that it should better say:

|  o  <MacAlgorithm>: The MAC algorithm used by the CT-KIP server.

Please check.

(4)  [selection of data formats]

Section 3.8.6 and the XML Schema in Appendix A *require* the use
of image data formats partly entangled with IPR issues, for the
<ServiceLogo> : image/gif and image/jpeg.
The IETF once has developed the open image/png format (RFC 2083)
as an Internet Standard alternative, in particular for use over
HTTP.

I'd therefore appreciate this popular format being allowed as well
in future revisions of the specification.

(5)  [another XML Schema inconsistency]

The XML Schema fragment in Section 3.9.3 refers to a non-existent
base type.  The correction needed is nearly obvious.

Near the bottom of page 28, the XML Schema lines,

     <xs:complexContent>
|      <xs:extension base="ExtensionType">
         <xs:sequence>
                          ^^
should say:

     <xs:complexContent>
|      <xs:extension base="AbstractExtensionType">
         <xs:sequence>
                          ^^^^^^^^^^

(6)  [yet another XML Schema inconsistency]

The XML Schema in Appendix A apparently has been truncated in an
amusing way.
The full text needed can be retrieved from page 21 of the RFC.

In the lower half of page 42, RFC 4758 says:

   <xs:complexType name="PayloadType">
     <xs:annotation>
\      <xs:documentation xml:lang="en">
/      </xs:documentation>
     </xs:annotation>

It should say:

   <xs:complexType name="PayloadType">
     <xs:annotation>
       <xs:documentation xml:lang="en">
|        Currently, only the nonce is defined.  In future versions,
|        other payloads may be defined, e.g., for one-roundtrip
|        initialization protocols.
       </xs:documentation>
     </xs:annotation>

(7)  [XML errors in examples]

The CT-KIP Message examples in Appendix B contain two significant
XML errors.

(7a)

At the beginning of Section B.2, on mid-page 46, RFC 4758 says:

   <CT-KIPTrigger
     xmlns= [...]

Apparently, the XML start line has been dropped. The RFC should say:

|  <?xml version="1.0" encoding="UTF-8"?>
   <CT-KIPTrigger
     xmlns= [...]

(7b)

In Section B.4, an inappropriate Status value is supplied,
contrary to the text in Section 3.8.4 -- cf. 'Status' bullet
in the upper half of page 22.

In Section B.4, on mid-page 47, RFC 4758 says:

   <ServerHello
     xmlns=
   "http://www.rsasecurity.com/rsalabs/otps/schemas/2005/12/ct-kip#"
     xmlns:ds="http://www.w3.org/2000/09/xmldsig#"
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
|    Version="1.0" SessionID="4114" Status="Success">
                                            ^^^^^^^
It should say:

   <ServerHello
     xmlns=
   "http://www.rsasecurity.com/rsalabs/otps/schemas/2005/12/ct-kip#"
     xmlns:ds="http://www.w3.org/2000/09/xmldsig#"
     xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
|    Version="1.0" SessionID="4114" Status="Continue">
                                            ^^^^^^^^

(8)  [mathematical clarification]

Appendix D repeatedly uses the "ROUND" function where in fact it
should use the "CEIL" function (3 instances: on pp. 49, 51, and 52).

Admittedly, the prose text says talks about "rounding up", but who
looks at the prose when the formula is so clear ??

To eliminate the ambiguity, this issue should be clarified.

Please comment.

All but item (4), and item (3) if I am wrong there, seem to be
appropriate for an Errata Note.

Preferrably, you should submit an Author's Errata Note to the
RFC Editor's RFC Errata web pages, making freely use of the
material supplied above.  But if you like, I can formally
submit an Errata Note on my own, with your consent.

Best regards,
  Alfred Hönes.

-- 

+------------------------+--------------------------------------------+
| TR-Sys Alfred Hoenes   |  Alfred Hoenes   Dipl.-Math., Dipl.-Phys.  |
| Gerlinger Strasse 12   |  Phone: (+49)7156/9635-0, Fax: -18         |
| D-71254  Ditzingen     |  E-Mail:  [email-masked]                     |
+------------------------+--------------------------------------------+